#!/usr/bin/perl
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#====================================================================
# Name			: adb_manager.pl
# Date			: 2014-04-02
# Author		: Haui, haui45@web.de 
# Version		: 0.1
# Copyright		: GPL
# Description	: 
#====================================================================

use strict;
use warnings;
#use 5.10.0;
#use feature 'say';

my @adb_commands = ("reboot", "reboot bootloader", "remount", "logcat", "pull", "push", "shell" );

my $adb = ""; # set the path to your adb executable if it is
# not in $PATH
my $adb_in_path = 0;

if($adb eq ""){
	$adb = `which adb`or die "adb not found";
	$adb_in_path = 1;
}
chomp $adb;

sub enumerate_devices(){

	my @devices = `$adb devices` or die $!;

	@devices = grep /device[^s]/, @devices;

	@devices = map {(split())[0]} @devices;
	chomp @devices;

	foreach my $serial(@devices){
		my $manufacturer = `$adb -s $serial shell getprop ro.product.manufacturer` or die $!;
		my $model = `$adb -s $serial shell getprop ro.product.model` or die $!;
		$model =~ s#[\r\n]##g;
		$manufacturer =~ s#[\r\n]##g;
		my $str = "|   $serial $manufacturer $model   |";
		print "=" x length($str) . "\n";
		print "$str\n";
		print "=" x length($str) . "\n";
		$adb = "adb" if($adb_in_path);
		foreach my $cmd (@adb_commands){
			print "$adb -s $serial $cmd\n";
		}
			print "$adb -s $serial\b\b\b\n";
		print "\n---------------------\n\n";
	}
}


while(1){
	enumerate_devices() ;
	sleep 5;
}
